program Project2;
{$APPTYPE CONSOLE}
uses
  sysutils,
  Classes,
  TypInfo,
  StdCtrls,
  Forms,
  Dialogs,
  PaxProgram,
  PaxRegister;

type
  TMyHandler = class
  public
    procedure CreateObjectHandler(Sender: TPaxProgram;
                                  Instance: TObject);
    procedure MapTableClassRefHandler(Sender: TPaxProgram;
       const FullName: String;
       Global: Boolean; var ClassRef: TClass);
    procedure MapTableProcAddressHandler(Sender: TPaxProgram;
       const FullName: String; OverCount: Byte;
       Global: Boolean; var Address: Pointer);
  end;

procedure TMyHandler.CreateObjectHandler(Sender: TPaxProgram;
                                  Instance: TObject);
var
  pti: PTypeInfo;
  ptd: PTypeData;
  S: String;
begin
  writeln('OnCreateObject:');

  if Instance is TForm then
  begin
    pti := Instance.ClassInfo;
    ptd := GetTypeData(pti);
    if FileExists(ptd^.UnitName + '.dfm') then
      Sender.LoadDFMFile(Instance, ptd^.UnitName + '.dfm');
  end;
end;

procedure TMyHandler.MapTableClassRefHandler(Sender: TPaxProgram;
       const FullName: String;
       Global: Boolean; var ClassRef: TClass);
begin
  if CompareText(FullName, 'Classes.TComponent') = 0 then
    ClassRef := Classes.TComponent
  else if CompareText(FullName, 'Forms.TCustomForm') = 0 then
    ClassRef := Forms.TCustomForm
  else if CompareText(FullName, 'Forms.TForm') = 0 then
    ClassRef := Forms.TForm
  else if CompareText(FullName, 'StdCtrls.TButton') = 0 then
    ClassRef := StdCtrls.TButton;
end;

procedure TMyHandler.MapTableProcAddressHandler(Sender: TPaxProgram;
       const FullName: String; OverCount: Byte;
       Global: Boolean; var Address: Pointer);
begin
  if CompareText(FullName, 'SysUtils.IntToStr') = 0 then
    Address := @ SysUtils.IntToStr
  else if CompareText(FullName, 'Forms.TCustomForm.ShowModal') = 0 then
    Address := @ Forms.TCustomForm.ShowModal
  else if CompareText(FullName, 'Forms.TForm.Create') = 0 then
    Address := @ Forms.TForm.Create
  else if CompareText(FullName, 'Dialogs.ShowMessage') = 0 then
    Address := @ Dialogs.ShowMessage;
end;

var
  MyHandler: TMyHandler;

var
  PaxProgram1: TPaxProgram;
begin
  try

    // Use compiled units (pcu-files) at run-tme as run-time packages

    PaxProgram1 := TPaxProgram.Create(nil);
    PaxProgram1.OnCreateObject := MyHandler.CreateObjectHandler;
    try
      PaxProgram1.OnMapTableClassRef := MyHandler.MapTableClassRefHandler;
      PaxProgram1.OnMapTableProcAddress := MyHandler.MapTableProcAddressHandler;

      PaxProgram1.LoadFromFile('script.bin');
      PaxProgram1.MapGlobal;
      PaxProgram1.Run;
    finally
      PaxProgram1.Free;
    end;

  finally
    MyHandler.Free;
  end;

  writeln('Press any key...');
  Readln;
end.

